searchData={"items":[{"type":"module","title":"Quokka","doc":"Quokka is a formatter plugin with stronger opinions on code organization, multi-line defs and other code-style matters.","ref":"Quokka.html"},{"type":"function","title":"Quokka.ast_to_string/3","doc":"Turns an ast and comments back into code, formatting it along the way.","ref":"Quokka.html#ast_to_string/3"},{"type":"module","title":"Quokka.AliasEnv","doc":"A datastructure for maintaining something like compiler alias state when traversing AST.\n\nNot anywhere as correct as what the compiler gives us, but close enough for open source work.\n\nA alias env is a map from an alias's `as` to its resolution in a context.\n\nGiven the ast for\n\n    alias Foo.Bar\n\nwe'd create the env:\n\n    %{:Bar => [:Foo, :Bar]}","ref":"Quokka.AliasEnv.html"},{"type":"function","title":"Quokka.AliasEnv.define/2","doc":"","ref":"Quokka.AliasEnv.html#define/2"},{"type":"function","title":"Quokka.AliasEnv.expand/2","doc":"","ref":"Quokka.AliasEnv.html#expand/2"},{"type":"behaviour","title":"Quokka.Style","doc":"A Style takes AST and returns a transformed version of that AST.\n\nBecause these transformations involve traversing trees (the \"T\" in \"AST\"), we wrap the AST in a structure\ncalled a Zipper to facilitate walking the trees.","ref":"Quokka.Style.html"},{"type":"function","title":"Quokka.Style.comments_for_lines/3","doc":"Gets all comments in range start_line..last_line, and any comments immediately before start_line.s\n\n  1. code\n  2. # a\n  3. # b\n  4. code # c\n  5. # d\n  6. code\n  7. # e\n\nhere, comments_for_lines(comments, 4, 6) is \"a\", \"b\", \"c\", \"d\"","ref":"Quokka.Style.html#comments_for_lines/3"},{"type":"function","title":"Quokka.Style.comments_for_node/2","doc":"Returns all comments \"for\" a node, including on the line before it.\nsee `comments_for_lines` for more","ref":"Quokka.Style.html#comments_for_node/2"},{"type":"function","title":"Quokka.Style.displace_comments/2","doc":"Set the line of all comments with `line` in `range_start..range_end` to instead have line `range_start`","ref":"Quokka.Style.html#displace_comments/2"},{"type":"function","title":"Quokka.Style.do_block?/1","doc":"","ref":"Quokka.Style.html#do_block?/1"},{"type":"function","title":"Quokka.Style.ensure_block_parent/1","doc":"Returns the current node (wrapped in a `__block__` if necessary) if it's a valid place to insert additional nodes","ref":"Quokka.Style.html#ensure_block_parent/1"},{"type":"function","title":"Quokka.Style.find_nearest_block/1","doc":"Returns a zipper focused on the nearest node where additional nodes can be inserted (a \"block\").\n\nThe nearest node is either the current node, an ancestor, or one of those two but wrapped in a new `:__block__` node.","ref":"Quokka.Style.html#find_nearest_block/1"},{"type":"function","title":"Quokka.Style.max_line/1","doc":"","ref":"Quokka.Style.html#max_line/1"},{"type":"function","title":"Quokka.Style.meta/1","doc":"","ref":"Quokka.Style.html#meta/1"},{"type":"function","title":"Quokka.Style.order_line_meta_and_comments/3","doc":"","ref":"Quokka.Style.html#order_line_meta_and_comments/3"},{"type":"function","title":"Quokka.Style.reset_newlines/1","doc":"Takes a list of nodes and clumps them up, setting `end_of_expression: [newlines: x]` to 1 for all but the final node,\nwhich gets 2 instead, (hopefully!) creating an empty line before whatever follows.","ref":"Quokka.Style.html#reset_newlines/1"},{"type":"function","title":"Quokka.Style.reset_newlines/2","doc":"","ref":"Quokka.Style.html#reset_newlines/2"},{"type":"callback","title":"Quokka.Style.run/2","doc":"`run` will be used with `Zipper.traverse_while/3`, meaning it will be executed on every node of the AST.\n\nYou can skip traversing parts of the tree by returning a Zipper that's further along in the traversal, for example\nby calling `Zipper.skip(zipper)` to skip an entire subtree you know is of no interest to your Style.","ref":"Quokka.Style.html#c:run/2"},{"type":"function","title":"Quokka.Style.set_line/3","doc":"Recursively sets `:line` meta to `line`. Deletes `:newlines` unless `delete_lines: false` is passed","ref":"Quokka.Style.html#set_line/3"},{"type":"function","title":"Quokka.Style.shift_comments/2","doc":"Perform a series of shifts in a single pass.\n\nWhen shifting comments from block A to block B, naively using two passes of `shift_comments/3` would result\nin all comments ending up in either region A or region B (because A would move to B, then all B back to A)\nThis function exists to make sure that a comment is only moved once during the swap.","ref":"Quokka.Style.html#shift_comments/2"},{"type":"function","title":"Quokka.Style.shift_comments/3","doc":"Change the `line` of all comments with `line` in `range` by adding `delta` to it.\nA positive delta will move the lines further down a file, while a negative delta will move them up.","ref":"Quokka.Style.html#shift_comments/3"},{"type":"function","title":"Quokka.Style.shift_line/2","doc":"Recursively updates `:line` meta by adding `delta`","ref":"Quokka.Style.html#shift_line/2"},{"type":"function","title":"Quokka.Style.update_all_meta/2","doc":"Traverses an ast node, updating all nodes' meta with `meta_fun`","ref":"Quokka.Style.html#update_all_meta/2"},{"type":"function","title":"Quokka.Style.without_meta/1","doc":"prewalks ast and sets all meta to `nil`. useful for comparing AST without meta (line numbers, etc) interfering","ref":"Quokka.Style.html#without_meta/1"},{"type":"type","title":"Quokka.Style.context/0","doc":"","ref":"Quokka.Style.html#t:context/0"},{"type":"module","title":"Quokka.Style.Blocks","doc":"Simple 1-1 rewrites all crammed into one module to make for more efficient traversals\n\nCredo Rules addressed:\n\n* Credo.Check.Readability.LargeNumbers\n* Credo.Check.Readability.ParenthesesOnZeroArityDefs\n* Credo.Check.Readability.WithSingleClause\n* Credo.Check.Refactor.CondStatements\n* Credo.Check.Refactor.RedundantWithClauseResult\n* Credo.Check.Refactor.WithClauses","ref":"Quokka.Style.Blocks.html"},{"type":"function","title":"Quokka.Style.Blocks.run/2","doc":"","ref":"Quokka.Style.Blocks.html#run/2"},{"type":"module","title":"Quokka.Style.CommentDirectives","doc":"Leave a comment for Quokka asking it to maintain code in a certain way.\n\n`# quokka:sort` maintains sorting of wordlists (by string comparison) and lists (string comparison of code representation)","ref":"Quokka.Style.CommentDirectives.html"},{"type":"function","title":"Quokka.Style.CommentDirectives.run/2","doc":"","ref":"Quokka.Style.CommentDirectives.html#run/2"},{"type":"module","title":"Quokka.Style.Configs","doc":"Orders `Config.config/2,3` stanzas in configuration files.\n\n- ordering is done only within immediate-sibling config statements\n- assignments are moved above the configuration blocks\n- any non `config/2,3` or assignment (`=/2`) calls mark the end of a sorting block.\n  this is support having conditional blocks (`if/case/cond`) and `import_config` stanzas between blocks","ref":"Quokka.Style.Configs.html"},{"type":"module","title":"Breakages - Quokka.Style.Configs","doc":"If you configure the same values multiple times, Quokka may swap their orders\n\n**Before**\n\n  line 04: config :foo, bar: :zab\n  line 40: config :foo, bar: :baz\n\n  # Application.fetch_env!(:foo)[:bar] => :baz\n\n**After**\n\n  line 04: config :foo, bar: :baz\n  line 05: config :foo, bar: :zab\n\n  # Application.fetch_env!(:foo)[:bar] => :zab\n\n**Fix**\n\nThe reason Quokka sorts configuration is to help you noticed these duplicated configuration stanzas.\nDelete the duplicative/erroneous stanza and life will be good.","ref":"Quokka.Style.Configs.html#module-breakages"},{"type":"function","title":"Quokka.Style.Configs.run/2","doc":"","ref":"Quokka.Style.Configs.html#run/2"},{"type":"module","title":"Quokka.Style.Defs","doc":"Styles function heads so that they're as small as possible.\n\nThe goal is that a function head fits on a single line.\n\nThis isn't a Credo issue, and the formatter is fine with either approach. But Quokka has opinions!\n\nEx:\n\nThis long declaration\n\n    def foo(%{\n      bar: baz\n    }) do\n      ...\n    end\n\nBecomes\n\n    def foo(%{bar: baz}) do\n      ...\n    end","ref":"Quokka.Style.Defs.html"},{"type":"function","title":"Quokka.Style.Defs.run/2","doc":"","ref":"Quokka.Style.Defs.html#run/2"},{"type":"module","title":"Quokka.Style.Deprecations","doc":"Transformations to soft or hard deprecations introduced on newer Elixir releases","ref":"Quokka.Style.Deprecations.html"},{"type":"function","title":"Quokka.Style.Deprecations.run/2","doc":"","ref":"Quokka.Style.Deprecations.html#run/2"},{"type":"module","title":"Quokka.Style.ModuleDirectives","doc":"Styles up module directives!\n\nThis Style will expand multi-aliases/requires/imports/use and sort the directive within its groups (except `use`s, which cannot be sorted)\nIt also adds a blank line after each directive group.","ref":"Quokka.Style.ModuleDirectives.html"},{"type":"module","title":"Credo rules - Quokka.Style.ModuleDirectives","doc":"Rewrites for the following Credo rules:\n\n  * `Credo.Check.Consistency.MultiAliasImportRequireUse` (force expansion)\n  * `Credo.Check.Readability.AliasOrder` (we sort `__MODULE__`, which credo doesn't)\n  * `Credo.Check.Readability.MultiAlias`\n  * `Credo.Check.Readability.StrictModuleLayout` (see section below for details)\n  * `Credo.Check.Readability.UnnecessaryAliasExpansion`\n  * `Credo.Check.Design.AliasUsage`","ref":"Quokka.Style.ModuleDirectives.html#module-credo-rules"},{"type":"module","title":"Strict Layout - Quokka.Style.ModuleDirectives","doc":"Modules directives are sorted into the following order:\n\n  * `@shortdoc`\n  * `@moduledoc`\n  * `@behaviour`\n  * `use`\n  * `import`\n  * `alias`\n  * `require`\n  * everything else (unchanged)","ref":"Quokka.Style.ModuleDirectives.html#module-strict-layout"},{"type":"function","title":"Quokka.Style.ModuleDirectives.moduledoc_placeholder/0","doc":"","ref":"Quokka.Style.ModuleDirectives.html#moduledoc_placeholder/0"},{"type":"function","title":"Quokka.Style.ModuleDirectives.run/2","doc":"","ref":"Quokka.Style.ModuleDirectives.html#run/2"},{"type":"module","title":"Quokka.Style.Pipes","doc":"Styles pipes! In particular, don't make pipe chains of only one pipe, and some persnickety pipe chain start stuff.\n\nRewrites for the following Credo rules:\n\n  * Credo.Check.Readability.BlockPipe\n  * Credo.Check.Readability.OneArityFunctionInPipe\n  * Credo.Check.Readability.PipeIntoAnonymousFunctions\n  * Credo.Check.Readability.SinglePipe\n  * Credo.Check.Refactor.FilterCount\n  * Credo.Check.Refactor.MapInto\n  * Credo.Check.Refactor.MapJoin\n  * Credo.Check.Refactor.PipeChainStart, excluded_functions: [\"from\"]","ref":"Quokka.Style.Pipes.html"},{"type":"function","title":"Quokka.Style.Pipes.run/2","doc":"","ref":"Quokka.Style.Pipes.html#run/2"},{"type":"module","title":"Quokka.Style.SingleNode","doc":"Simple 1-1 rewrites all crammed into one module to make for more efficient traversals\n\nCredo Rules addressed:\n\n* Credo.Check.Consistency.ParameterPatternMatching\n* Credo.Check.Readability.LargeNumbers\n* Credo.Check.Readability.ParenthesesOnZeroArityDefs\n* Credo.Check.Readability.PreferImplicitTry\n* Credo.Check.Readability.StringSigils\n* Credo.Check.Readability.WithSingleClause\n* Credo.Check.Refactor.CondStatements\n* Credo.Check.Refactor.RedundantWithClauseResult\n* Credo.Check.Refactor.WithClauses","ref":"Quokka.Style.SingleNode.html"},{"type":"function","title":"Quokka.Style.SingleNode.run/2","doc":"","ref":"Quokka.Style.SingleNode.html#run/2"},{"type":"module","title":"Quokka.Zipper","doc":"Implements a Zipper for the Elixir AST based on Gérard Huet [Functional pearl: the\nzipper](https://www.st.cs.uni-saarland.de/edu/seminare/2005/advanced-fp/docs/huet-zipper.pdf) paper and\nClojure's `clojure.zip` API.\n\nA zipper is a data structure that represents a location in a tree from the\nperspective of the current node, also called *focus*. It is represented by a\n2-tuple where the first element is the focus and the second element is the\nmetadata/context. The metadata is `nil` when the focus is the topmost node","ref":"Quokka.Zipper.html"},{"type":"function","title":"Quokka.Zipper.any?/2","doc":"Traverses `zipper`, returning true when `fun.(Zipper.node(zipper))` is truthy, or false otherwise","ref":"Quokka.Zipper.html#any?/2"},{"type":"function","title":"Quokka.Zipper.append_child/2","doc":"Inserts the item as the rightmost child of the node at this zipper,\nwithout moving.","ref":"Quokka.Zipper.html#append_child/2"},{"type":"function","title":"Quokka.Zipper.children/1","doc":"Returns a list of children of the node.","ref":"Quokka.Zipper.html#children/1"},{"type":"function","title":"Quokka.Zipper.down/1","doc":"Returns the zipper of the leftmost child of the node at this zipper, or\nnil if no there's no children.","ref":"Quokka.Zipper.html#down/1"},{"type":"function","title":"Quokka.Zipper.find/3","doc":"Returns a zipper to the node that satisfies the predicate function, or `nil`\nif none is found.\n\nThe optional second parameters specifies the `direction`, defaults to\n`:next`.","ref":"Quokka.Zipper.html#find/3"},{"type":"function","title":"Quokka.Zipper.insert_child/2","doc":"Inserts the item as the leftmost child of the node at this zipper,\nwithout moving.","ref":"Quokka.Zipper.html#insert_child/2"},{"type":"function","title":"Quokka.Zipper.insert_left/2","doc":"Inserts the item as the left sibling of the node at this zipper, without\nmoving. Raises an `ArgumentError` when attempting to insert a sibling at the\ntop level.","ref":"Quokka.Zipper.html#insert_left/2"},{"type":"function","title":"Quokka.Zipper.insert_right/2","doc":"Inserts the item as the right sibling of the node at this zipper, without\nmoving. Raises an `ArgumentError` when attempting to insert a sibling at the\ntop level.","ref":"Quokka.Zipper.html#insert_right/2"},{"type":"function","title":"Quokka.Zipper.insert_siblings/2","doc":"Inserts many siblings to the right.\nIf the node is at the top of the tree, builds a new root `:__block__` while maintaining focus on the current node.\n\nEquivalent to\n\n    Enum.reduce(siblings, zipper, &Zipper.insert_right(&2, &1))","ref":"Quokka.Zipper.html#insert_siblings/2"},{"type":"function","title":"Quokka.Zipper.left/1","doc":"Returns the zipper of the left sibling of the node at this zipper, or nil.","ref":"Quokka.Zipper.html#left/1"},{"type":"function","title":"Quokka.Zipper.leftmost/1","doc":"Returns the leftmost sibling of the node at this zipper, or itself.","ref":"Quokka.Zipper.html#leftmost/1"},{"type":"function","title":"Quokka.Zipper.next/1","doc":"Returns the following zipper in depth-first pre-order.","ref":"Quokka.Zipper.html#next/1"},{"type":"function","title":"Quokka.Zipper.node/1","doc":"Returns the node at the zipper.","ref":"Quokka.Zipper.html#node/1"},{"type":"function","title":"Quokka.Zipper.prepend_siblings/2","doc":"Inserts many siblings to the left.\nIf the node is at the top of the tree, builds a new root `:__block__` while maintaining focus on the current node.\n\nEquivalent to\n\n    Enum.reduce(siblings, zipper, &Zipper.insert_left(&2, &1))","ref":"Quokka.Zipper.html#prepend_siblings/2"},{"type":"function","title":"Quokka.Zipper.prev/1","doc":"Returns the previous zipper in depth-first pre-order.\nReturns nil if the tree is already at the top.","ref":"Quokka.Zipper.html#prev/1"},{"type":"function","title":"Quokka.Zipper.reduce_while/3","doc":"Same as `traverse_while/3` except it only returns the acc, saving the work of returning to the top of the zipper.\n\nFor that reason the `:halt` tuple is instead just a 2-ple of `{:halt, acc}`","ref":"Quokka.Zipper.html#reduce_while/3"},{"type":"function","title":"Quokka.Zipper.remove/1","doc":"Removes the node at the zipper, returning the zipper that would have preceded\nit in a depth-first walk.","ref":"Quokka.Zipper.html#remove/1"},{"type":"function","title":"Quokka.Zipper.replace/2","doc":"Replaces the current node in the zipper with a new node.","ref":"Quokka.Zipper.html#replace/2"},{"type":"function","title":"Quokka.Zipper.replace_children/2","doc":"Returns the zipper with the current children of the node replaced with `children`","ref":"Quokka.Zipper.html#replace_children/2"},{"type":"function","title":"Quokka.Zipper.right/1","doc":"Returns the zipper of the right sibling of the node at this zipper, or nil.","ref":"Quokka.Zipper.html#right/1"},{"type":"function","title":"Quokka.Zipper.rightmost/1","doc":"Returns the rightmost sibling of the node at this zipper, or itself.","ref":"Quokka.Zipper.html#rightmost/1"},{"type":"function","title":"Quokka.Zipper.root/1","doc":"Walks the zipper all the way up and returns the root node.","ref":"Quokka.Zipper.html#root/1"},{"type":"function","title":"Quokka.Zipper.skip/2","doc":"Returns the zipper of the right sibling of the node at this zipper, or the\nnext zipper when no right sibling is available.\n\nThis allows to skip subtrees while traversing the siblings of a node.\n\nThe optional second parameters specifies the `direction`, defaults to\n`:next`.\n\nIf no right/left sibling is available, this function returns the same value as\n`next/1`/`prev/1`.\n\nThe function `skip/1` behaves like the `:skip` in `traverse_while/2` and\n`traverse_while/3`.","ref":"Quokka.Zipper.html#skip/2"},{"type":"function","title":"Quokka.Zipper.top/1","doc":"Walks the zipper all the way up and returns the top zipper.","ref":"Quokka.Zipper.html#top/1"},{"type":"function","title":"Quokka.Zipper.traverse/2","doc":"Traverses the tree in depth-first pre-order calling the given function for\neach node.\n\nIf the zipper is not at the top, just the subtree will be traversed.\n\nThe function must return a zipper.","ref":"Quokka.Zipper.html#traverse/2"},{"type":"function","title":"Quokka.Zipper.traverse/3","doc":"Traverses the tree in depth-first pre-order calling the given function for\neach node with an accumulator.\n\nIf the zipper is not at the top, just the subtree will be traversed.","ref":"Quokka.Zipper.html#traverse/3"},{"type":"function","title":"Quokka.Zipper.traverse_while/2","doc":"Traverses the tree in depth-first pre-order calling the given function for\neach node.\n\nThe traversing will continue if the function returns `{:cont, zipper}`,\nskipped for `{:skip, zipper}` and halted for `{:halt, zipper}`\n\nIf the zipper is not at the top, just the subtree will be traversed.\n\nThe function must return a zipper.","ref":"Quokka.Zipper.html#traverse_while/2"},{"type":"function","title":"Quokka.Zipper.traverse_while/3","doc":"Traverses the tree in depth-first pre-order calling the given function for\neach node with an accumulator.\n\nThe traversing will continue if the function returns `{:cont, zipper, acc}`,\nskipped for `{:skip, zipper, acc}` and halted for `{:halt, zipper, acc}`\n\nIf the zipper is not at the top, just the subtree will be traversed.","ref":"Quokka.Zipper.html#traverse_while/3"},{"type":"function","title":"Quokka.Zipper.up/1","doc":"Returns the zipper of the parent of the node at this zipper, or nil if at the\ntop.","ref":"Quokka.Zipper.html#up/1"},{"type":"function","title":"Quokka.Zipper.update/2","doc":"Replaces the current node in the zipper with the result of applying `fun` to\nthe node.","ref":"Quokka.Zipper.html#update/2"},{"type":"function","title":"Quokka.Zipper.zip/1","doc":"Creates a zipper from a tree node.","ref":"Quokka.Zipper.html#zip/1"},{"type":"type","title":"Quokka.Zipper.command/0","doc":"","ref":"Quokka.Zipper.html#t:command/0"},{"type":"opaque","title":"Quokka.Zipper.path/0","doc":"","ref":"Quokka.Zipper.html#t:path/0"},{"type":"type","title":"Quokka.Zipper.t/0","doc":"","ref":"Quokka.Zipper.html#t:t/0"},{"type":"type","title":"Quokka.Zipper.tree/0","doc":"","ref":"Quokka.Zipper.html#t:tree/0"},{"type":"type","title":"Quokka.Zipper.zipper/0","doc":"","ref":"Quokka.Zipper.html#t:zipper/0"},{"type":"exception","title":"Quokka.StyleError","doc":"Wraps errors raised by Styles during tree traversal.","ref":"Quokka.StyleError.html"},{"type":"function","title":"Quokka.StyleError.message/1","doc":"","ref":"Quokka.StyleError.html#message/1"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nQuokka follows [Semantic Versioning](https://semver.org) and\n[Common Changelog: Guiding Principles](https://common-changelog.org/#12-guiding-principles)\n\n## [2.4.1] - 2025-03-11","ref":"changelog.html"},{"type":"extras","title":"Fixes - Changelog","doc":"- Change default schema autosort order to put fields first. When fields don't come first, this can cause errors because some association fields require the field already being defined.\n\n## [2.4.0] - 2025-03-10","ref":"changelog.html#fixes"},{"type":"extras","title":"Improvements - Changelog","doc":"- Add option to autosort schemas. `:schema` is now a supported option in `autosort`. Furthermore, order can be specified as `autosort: [schema: [:field, :many_to_many, :has_many, ...]]`.\n\n## [2.3.1] - 2025-03-06","ref":"changelog.html#improvements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix alias lifting when a variable matches the directive. Before, if you named a variable `import` or `use` (why would you do that?), it would break the alias lifting.\n\n## [2.3.0] - 2025-03-06","ref":"changelog.html#fixes"},{"type":"extras","title":"Improvements - Changelog","doc":"Credo doesn't warn about alias lifting for `behaviour, use, import` directives (unless there are aliases inside opts). Therefore, to match credo:\n- Don't lift `behaviour` aliases at all.\n- Only lift `use` and `import` aliases if they were going to be lifted anyways (credo wouldn't yell either way, but it seems sensible to lift an alias if it's already lifted).\n\n## [2.2.0] - 2025-03-04","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements - Changelog","doc":"- Check `.formatter.exs` for `line_length` config. Use the minimum of the credo and formatter `line_length`.","ref":"changelog.html#improvements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Do not sort `use` directives. Some `use` directives depend on others coming first, so sorting them can break code. This bug was introduced in 2.1.0.\n\n## [2.1.0] - 2025-03-02","ref":"changelog.html#fixes"},{"type":"extras","title":"Improvements - Changelog","doc":"#### New options\n\n- `autosort`: Sort all maps and/or defstructs in your codebase. Quokka will skip sorting maps that have comments inside them, though sorting can still be forced with `# quokka:sort`\n\n- `piped_function_exclusions` allows you to specify certain functions that won't be rewritten into a pipe. Particularly good for things like Ecto's `subquery` macro. Example:\n\n```elixir\n# Before\nsubquery(\n  base_query()\n  |> select([:id, :name])\n  |> where([_, id], id > 100)\n  |> limit(1)\n)\n```\nwould normally be rewritten to:\n\n```elixir\n  base_query()\n  |> select([:id, :name])\n  |> where([_, id], id > 100)\n  |> limit(1)\n  |> subquery()\n```\n\nbut with the option set like this, it will not be rewritten:\n```elixir\n# .formatter.exs\nquokka: [\n  piped_function_exclusions: [:\"Ecto.Query.subquery\"]\n]\n```\n\n#### Deprecations\n\n- For elixir 1.18 and above, Quokka will rewrite `%Foo{x | y} => %{x | y}`\n- For elixir 1.17 and above, Quokka will replace `:timer.units(x)` with `to_time(unit: x)`","ref":"changelog.html#improvements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Lift aliases that were already lifted\n- Lift aliases from inside module directives like `use` if the directive type comes after the alias.\n- `with` redundant body + non-arrow behind redundant clause\n\n\n## [2.0.0] - 2025-02-20","ref":"changelog.html#fixes"},{"type":"extras","title":"Improvements - Changelog","doc":"#### Configuration filtering with :only and :exclude\n\nQuokka now supports filtering which rewrites to apply using the `:only` and `:exclude` configuration options. This allows teams to gradually adopt Quokka's rewrites by explicitly including or excluding specific ones.\n\nExample configuration in `.formatter.exs`:\n\n```elixir\n[\n  # Only apply these specific rewrites\n  only: [:pipes, :aliases, :line_length],\n  \n  # Or exclude specific rewrites\n  exclude: [:sort_directives]\n]\n```\n\nSee the documentation for a complete list of available rewrite options.","ref":"changelog.html#improvements"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- Removed `newline_fixes_only` configuration option in favor of using `only: [:line_length]`\n- Removed `reorder_configs` configuration option in favor of using `only: [:configs]`\n- Removed `rewrite_deprecations` configuration option in favor of using `only: [:deprecations]`\n\n## [1.1.0] - 2025-02-14","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Improvements - Changelog","doc":"#### Line length formatting only\n\nIn order to phase this into large codebases, Quokka now supports formatting only the line length, the idea being that it is easier to review a diff where one commit is just compressing vertical code and the following is the substantive rewrites -- aka the rewrites that change the AST. In order to use this feature, use `newline_fixes_only: true | false` in the config. \n\n##### `# quokka:sort` Quokka's first comment directive\n\nQuokka will now keep a user-designated list or wordlist (`~w` sigil) sorted as part of formatting via the use of comments. Elements of the list are sorted by their string representation. It also works with maps, key-value pairs (sort by key), and `defstruct`, and even arbitrary ast nodes with a `do end` block.\n\nThe intention is to remove comments to humans, like `# Please keep this list sorted!`, in favor of comments to robots: `# quokka:sort`. Personally speaking, Quokka is much better at alphabetical-order than I ever will be.\n\nTo use the new directive, put it on the line before a list or wordlist.\n\nThis example:\n\n```elixir\n# quokka:sort\n[:c, :a, :b]\n\n# quokka:sort\n~w(a list of words)\n\n# quokka:sort\n@country_codes ~w(\n  en_US\n  po_PO\n  fr_CA\n  ja_JP\n)\n\n# quokka:sort\na_var =\n  [\n    Modules,\n    In,\n    A,\n    List\n  ]\n\n  # quokka:sort\n  my_macro \"some arg\" do\n    another_macro :q\n    another_macro :w\n    another_macro :e\n    another_macro :r\n    another_macro :t\n    another_macro :y\n  end\n```\n\nWould yield:\n\n```elixir\n# quokka:sort\n[:a, :b, :c]\n\n# quokka:sort\n~w(a list of words)\n\n# quokka:sort\n@country_codes ~w(\n  en_US\n  fr_CA\n  ja_JP\n  po_PO\n)\n\n# quokka:sort\na_var =\n  [\n    A,\n    In,\n    List,\n    Modules\n  ]\n\n# quokka:sort\nmy_macro \"some arg\" do\n  another_macro :e\n  another_macro :q\n  another_macro :r\n  another_macro :t\n  another_macro :w\n  another_macro :y\nend\n```\n#### Other improvements\n- General improvements around conflict detection, lifting in more correct places and fewer incorrect places.\n- Use knowledge of existing aliases to shorten invocations.\n\n    example:\n        alias A.B.C\n\n        A.B.C.foo()\n        A.B.C.bar()\n        A.B.C.baz()\n\n    becomes:\n        alias A.B.C\n\n        C.foo()\n        C.bar()\n        C.baz()\n\n- Config Sorting: improve comment handling when only sorting a few nodes.\n- Pipes: pipe-ifies when first arg to a function is a pipe. reach out if this happens in unstylish places in your code.\n- Pipes: unpiping assignments will make the assignment one-line when possible\n- Deprecations: 1.18 deprecations\n  - `List.zip` => `Enum.zip`\n  - `first..last = range` => `first..last//_ = range`","ref":"changelog.html#improvements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Support the credo config of the format `checks: %{enabled: [...], disabled: [...]}`, whereas previously it expected `checks: [...]}`\n- Pipes: optimizations are less likely to move comments\n- Don't pipify when the call is itself in a pipe (aka don't touch a |> b(c |> d() |>e()) |> f())\n\n## [1.0.0] - 2025-02-10\n\nQuokka is inspired by the wonderful [`elixir-styler`](https://github.com/adobe/elixir-styler) :heart:\n\nIt maintains the same directive that consistent coding standards can help teams\niterate quickly, but allows a few more affordances\n[via `.credo.exs` configuration](https://hexdocs.pm/credo/config_file.html).\nThis allows users with an already fine-tuned `.credo.exs` config to enjoy\nthe automatic rewrites and strong opinions of Quokka\n\nMore details about specific Credo rewrites and their configurability can be\nfound in [Quokka: Credo inspired rewrites](https://hexdocs.pm/quokka/readme.html#credo-inspired-rewrites).\n\nAdoption of opinionated code changes can be hard in larger code bases, so\nQuokka allows a few configuration options in `.formatter.exs` to help\nisolate big sets of potentially controversial or code breaking changes that\nmay need time for adoption. However, these may be removed in a future release.\nSee [Quokka: Configuration](https://hexdocs.pm/quokka/readme.html#configuration)\nfor more details.","ref":"changelog.html#fixes"},{"type":"extras","title":"Quokka","doc":"[![Hex.pm](https://img.shields.io/hexpm/v/quokka)](https://hex.pm/packages/quokka)\n[![Hexdocs.pm](https://img.shields.io/badge/docs-hexdocs.pm-purple)](https://hexdocs.pm/quokka)\n[![Github.com](https://github.com/smartrent/quokka/actions/workflows/ci.yml/badge.svg)](https://github.com/smartrent/quokka/actions)\n\n# Quokka\n\n \n\nQuokka is an Elixir formatter plugin that's combination of `mix format` and `mix credo`, except instead of telling you what's wrong, it just rewrites the code for you. Quokka is a fork of [Styler](https://github.com/adobe/elixir-styler) that checks the Credo config to determine which rules to rewrite. Many common, non-controversial Credo style rules are rewritten automatically, while the controversial Credo style rules are rewritten based on your Credo configuration so you can customize your style.\n\n> #### WARNING {: .warning}\n>\n> Quokka can change the behavior of your program!\n>\n> In some cases, this can introduce bugs. It goes without saying, but look over your changes before committing to main :)\n>\n> We recommend making changes in small chunks until all of the more dangerous\n> changes has been safely committed to the codebase","ref":"readme.html"},{"type":"extras","title":"Installation - Quokka","doc":"Add `:quokka` as a dependency to your project's `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:quokka, \"~> 2.4.0\", only: [:dev, :test], runtime: false},\n  ]\nend\n```\n\nThen add `Quokka` as a plugin to your `.formatter.exs` file\n\n```elixir\n[\n  plugins: [Quokka]\n]\n```\n\nAnd that's it! Now when you run `mix format` you'll also get the benefits of Quokka's Stylish Stylings.","ref":"readme.html#installation"},{"type":"extras","title":"First Run - Quokka","doc":"You may want to initially run Quokka in \"newline fixes only\" mode. This will only fix spacing issues, making future PRs _much_ smaller and easier to digest.\nSee the example in the configuration section if you wish to do this.\n\n**Speed**: Expect the first run to take some time as `Quokka` rewrites violations of styles and bottlenecks on disk I/O. Subsequent formats will take noticeably less time.","ref":"readme.html#first-run"},{"type":"extras","title":"Configuration - Quokka","doc":"Quokka primarily relies on the configurations of `.formatter.exs` and `Credo` (if available).\nHowever, there are some Quokka specific options that can also be specified\nin `.formatter.exs` to fine tune your setup:\n\n```elixir\n[\n  plugins: [Quokka],\n  quokka: [\n    autosort: [:map, :defstruct],\n    inefficient_function_rewrites: true | false,\n    files: %{\n      included: [\"lib/\", ...],\n      excluded: [\"lib/example.ex\", ...]\n    },\n    only: [\n      # Changes to blocks of code\n      :blocks\n      # Comment directives such as # quokka:sort\n      | :comment_directives\n      # Sorting config files\n      | :configs\n      # Minimizes function heads\n      | :defs\n      # Converts deprecations\n      | :deprecations\n      # SPECIAL CASE: excludes all modules and only does newline fixups\n      | :line_length\n      # Fixes for imports, aliases, etc.\n      | :module_directives\n      # Various fixes for pipes\n      | :pipes\n      # Inefficient function rewrites, large numbers get underscores, etc.\n      # Basically anything that doesn't fit into the categories above\n      | :single_node\n    ],\n    exclude: [\n      :blocks\n      | :comment_directives\n      | :configs\n      | :defs\n      | :deprecations\n      | :module_directives\n      | :pipes\n      | :single_node\n    ],\n    piped_function_exclusions: [:subquery, :\"Repo.update\", ...]\n  ]\n]\n```\n\n| Option                           | Description                                                                                                                                                                                                | Default                                                             |\n| -------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------- |\n| `:autosort`                      | Sort all maps and/or defstructs in your codebase. Quokka will skip sorting maps that have comments inside them, though sorting can still be forced with `# quokka:sort`.                                   | `[]`                                                                |\n| `:files`                         | Quokka gets files from `.formatter.exs[:inputs]`. However, in some cases you may need to selectively exclude/include files you wish to still run in `mix format`, but have different behavior with Quokka. | `%{included: [], excluded: []}` (all files included, none excluded) |\n| `:only`                          | Only include the given modules. The special `:line_length` option excludes all changes except line length fixups.                                                                                          | `[]` (all modules included)                                         |\n| `:exclude`                       | Exclude the given modules. This is just a convenience function that filters from the `:only` list.                                                                                                         | `[]` (all modules included)                                         |\n| `:inefficient_function_rewrites` | Rewrite inefficient functions to more efficient form                                                                                                                                                       | `true`                                                              |\n| `:piped_function_exclusions`     | Allows you to specify certain functions that won't be rewritten into a pipe. Particularly good for things like Ecto's `subquery` macro.                                                                    | `[]`                                                                |","ref":"readme.html#configuration"},{"type":"extras","title":"Credo inspired rewrites - Quokka","doc":"The power of Quokka comes from utilizing the opinions you've already made with\nCredo and going one step further to attempt rewriting them for you.\n\nBelow is a general overall of many Credo checks Quokka attempts to handle and\nsome additional useful details such as links to detailed documentation and if\nthe check can be configured further for fine tuning.\n\n> #### `:controversial` Credo checks {: .tip}\n>\n> Quokka allows all `:controversial` Credo checks to be configurable. In many cases,\n> a Credo check can also be disabled to prevent rewriting.\n\n<!-- tabs-open -->","ref":"readme.html#credo-inspired-rewrites"},{"type":"extras","title":"Credo.Check.Consistency - Quokka","doc":"| Credo Check                                                                                                       | Rewrite Description                            | Documentation                                                                       | Configurable |\n| ----------------------------------------------------------------------------------------------------------------- | ---------------------------------------------- | ----------------------------------------------------------------------------------- | ------------ |\n| [`.MultiAliasImportRequireUse`](https://hexdocs.pm/credo/Credo.Check.Consistency.MultiAliasImportRequireUse.html) | Expands multi-alias/import statements          | [Directive Expansion](docs/module_directives.md#directive-expansion)                |              |\n| [`.ParameterPatternMatching`](https://hexdocs.pm/credo/Credo.Check.Consistency.ParameterPatternMatching.html)     | Enforces consistent parameter pattern matching | [Parameter Pattern Matching](docs/styles.md#parameter-pattern-matching-consistency) |              |","ref":"readme.html#credo-check-consistency"},{"type":"extras","title":"Credo.Check.Design - Quokka","doc":"| Credo Check                                                                  | Rewrite Description       | Documentation                                            | Configurable |\n| ---------------------------------------------------------------------------- | ------------------------- | -------------------------------------------------------- | ------------ |\n| [`.AliasUsage`](https://hexdocs.pm/credo/Credo.Check.Design.AliasUsage.html) | Extracts repeated aliases | [Alias Lifting](docs/module_directives.md#alias-lifting) | ✓            |","ref":"readme.html#credo-check-design"},{"type":"extras","title":"Credo.Check.Readability - Quokka","doc":"| Credo Check                                                                                                       | Rewrite Description                               | Documentation                                                                                  | Configurable |\n| ----------------------------------------------------------------------------------------------------------------- | ------------------------------------------------- | ---------------------------------------------------------------------------------------------- | ------------ |\n| [`.AliasOrder`](https://hexdocs.pm/credo/Credo.Check.Readability.AliasOrder.html)                                 | Alphabetizes module directives                    | [Module Directives](docs/module_directives.md#directive-organization)                          | ✓            |\n| [`.BlockPipe`](https://hexdocs.pm/credo/Credo.Check.Readability.BlockPipe.html)                                   | (En\\|dis)ables piping into blocks                 | [Pipe Chains](docs/pipes.md#pipe-start)                                                        | ✓            |\n| [`.LargeNumbers`](https://hexdocs.pm/credo/Credo.Check.Readability.LargeNumbers.html)                             | Formats large numbers with underscores            | [Number Formatting](docs/styles.md#large-base-10-numbers)                                      | ✓            |\n| [`.MaxLineLength`](https://hexdocs.pm/credo/Credo.Check.Readability.MaxLineLength.html)                           | Enforces maximum line length                      | [Line Length](docs/styles.md#line-length)                                                      | ✓            |\n| [`.MultiAlias`](https://hexdocs.pm/credo/Credo.Check.Readability.MultiAlias.html)                                 | Expands multi-alias statements                    | [Module Directives](docs/module_directives.md#directive-expansion)                             | ✓            |\n| [`.OneArityFunctionInPipe`](https://hexdocs.pm/credo/Credo.Check.Readability.OneArityFunctionInPipe.html)         | Optimizes pipe chains with single arity functions | [Pipe Chains](docs/pipes.md#add-parenthesis-to-function-calls-in-pipes)                        |              |\n| [`.ParenthesesOnZeroArityDefs`](https://hexdocs.pm/credo/Credo.Check.Readability.ParenthesesOnZeroArityDefs.html) | Enforces consistent function call parentheses     | [Function Calls](docs/styles.md#add-parenthesis-to-0-arity-functions-and-macro-definitions)    | ✓            |\n| [`.PipeIntoAnonymousFunctions`](https://hexdocs.pm/credo/Credo.Check.Readability.PipeIntoAnonymousFunctions.html) | Optimizes pipes with anonymous functions          | [Pipe Chains](docs/pipes.md#add-then-2-when-defining-and-calling-anonymous-functions-in-pipes) |              |\n| [`.PreferImplicitTry`](https://hexdocs.pm/credo/Credo.Check.Readability.PreferImplicitTry.html)                   | Simplifies try expressions                        | [Control Flow Macros](docs/styles.md#implicit-try)                                             |              |\n| [`.SinglePipe`](https://hexdocs.pm/credo/Credo.Check.Readability.SinglePipe.html)                                 | Optimizes pipe chains                             | [Pipe Chains](docs/pipes.md#unpiping-single-pipes)                                             | ✓            |\n| [`.StringSigils`](https://hexdocs.pm/credo/Credo.Check.Readability.StringSigils.html)                             | Replaces strings with sigils                      | [Strings to Sigils](docs/styles.md#strings-to-sigils)                                          |              |\n| [`.StrictModuleLayout`](https://hexdocs.pm/credo/Credo.Check.Readability.StrictModuleLayout.html)                 | Enforces strict module layout                     | [Module Directives](docs/module_directives.md#directive-organization)                          | ✓            |\n| [`.UnnecessaryAliasExpansion`](https://hexdocs.pm/credo/Credo.Check.Readability.UnnecessaryAliasExpansion.html)   | Removes unnecessary alias expansions              | [Module Directives](docs/module_directives.md#directive-expansion)                             |              |\n| [`.WithSingleClause`](https://hexdocs.pm/credo/Credo.Check.Readability.WithSingleClause.html)                     | Simplifies with statements                        | [Control Flow Macros](docs/control_flow_macros.md#with)                                        |              |","ref":"readme.html#credo-check-readability"},{"type":"extras","title":"Credo.Check.Refactor - Quokka","doc":"| Credo Check                                                                                                  | Rewrite Description                     | Documentation                                                         | Configurable |\n| ------------------------------------------------------------------------------------------------------------ | --------------------------------------- | --------------------------------------------------------------------- | ------------ |\n| [`.CondStatements`](https://hexdocs.pm/credo/Credo.Check.Refactor.CondStatements.html)                       | Simplifies boolean expressions          | [Control Flow Macros](docs/control_flow_macros.md#cond)               |              |\n| [`.FilterCount`](https://hexdocs.pm/credo/Credo.Check.Refactor.FilterCount.html)                             | Optimizes filter + count operations     | [Styles](docs/styles.md#filter-count)                                 |              |\n| [`.MapInto`](https://hexdocs.pm/credo/Credo.Check.Refactor.MapInto.html)                                     | Optimizes map + into operations         | [Styles](docs/styles.md#map-into)                                     |              |\n| [`.MapJoin`](https://hexdocs.pm/credo/Credo.Check.Refactor.MapJoin.html)                                     | Optimizes map + join operations         | [Styles](docs/styles.md#map-join)                                     |              |\n| [`.NegatedConditionsInUnless`](https://hexdocs.pm/credo/Credo.Check.Refactor.NegatedConditionsInUnless.html) | Simplifies negated conditions in unless | [Control Flow Macros](docs/control_flow_macros.md#if-and-unless)      |              |\n| [`.NegatedConditionsWithElse`](https://hexdocs.pm/credo/Credo.Check.Refactor.NegatedConditionsWithElse.html) | Simplifies negated conditions with else | [Control Flow Macros](docs/control_flow_macros.md#negation-inversion) |              |\n| [`.PipeChainStart`](https://hexdocs.pm/credo/Credo.Check.Refactor.PipeChainStart.html)                       | Optimizes pipe chain start              | [Pipe Chains](docs/pipes.md#pipe-start)                               |              |\n| [`.RedundantWithClauseResult`](https://hexdocs.pm/credo/Credo.Check.Refactor.RedundantWithClauseResult.html) | Removes redundant with clause results   | [Control Flow Macros](docs/control_flow_macros.md#with)               |              |\n| [`.UnlessWithElse`](https://hexdocs.pm/credo/Credo.Check.Refactor.UnlessWithElse.html)                       | Simplifies unless with else             | [Control Flow Macros](docs/control_flow_macros.md#if-and-unless)      |              |\n| [`.WithClauses`](https://hexdocs.pm/credo/Credo.Check.Refactor.WithClauses.html)                             | Optimizes with clauses                  | [Control Flow Macros](docs/control_flow_macros.md#with)               |              |\n\n<!-- tabs-close -->","ref":"readme.html#credo-check-refactor"},{"type":"extras","title":"License - Quokka","doc":"Quokka is licensed under the Apache 2.0 license. See the [LICENSE file](LICENSE) for more details.","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.","ref":"license.html"},{"type":"extras","title":"Comment Directives (quokka:sort, ...)","doc":"# Comment Directives","ref":"comment_directives.html"},{"type":"extras","title":"Maintain static list order via `# quokka:sort` - Comment Directives (quokka:sort, ...)","doc":"Quokka can keep static values sorted for your team as part of its formatting pass. To instruct it to do so, replace any `# Please keep this list sorted!` notes you wrote to your teammates with `# quokka:sort`.\n\n#### Examples\n\n```elixir\n# quokka:sort\n[:c, :a, :b]\n\n# quokka:sort\n~w(a list of words)\n\n# quokka:sort\n@country_codes ~w(\n  en_US\n  po_PO\n  fr_CA\n  ja_JP\n)\n\n# quokka:sort\na_var =\n  [\n    Modules,\n    In,\n    A,\n    List\n  ]\n```\n\nWould yield:\n\n```elixir\n# quokka:sort\n[:a, :b, :c]\n\n# quokka:sort\n~w(a list of words)\n\n# quokka:sort\n@country_codes ~w(\n  en_US\n  fr_CA\n  ja_JP\n  po_PO\n)\n\n# quokka:sort\na_var =\n  [\n    A,\n    In,\n    List,\n    Modules\n  ]\n```","ref":"comment_directives.html#maintain-static-list-order-via-quokka-sort"},{"type":"extras","title":"Autosort - Comment Directives (quokka:sort, ...)","doc":"Quokka can autosort maps, defstructs, and schemas. To enable this feature, set `autosort: [:map, :defstruct, :schema]` in the config. The order of schema sorting can be customized in the following way:\n\n```elixir\nautosort: [:map, schema: [:field, :belongs_to]]\n```\n\nThe default order is: `[:field, :belongs_to, :has_many, :has_one, :many_to_many, :embeds_many, :embeds_one]`.\n\nQuokka will skip sorting entities that have comments inside them, though sorting can still be forced with `# quokka:sort`. Finally, when `autosort` is enabled, a specific entity can be skipped by adding `# quokka:skip-sort` on the line above it.\n\n#### Examples\n\nWhen `autosort: [:map]` is enabled:\n```elixir\n# quokka:skip-sort\n%{c: 3, b: 2, a: 1}\n\n%{c: 3, b: 2, a: 1}\n\n%{\n  c: 3,\n  b: 2,\n  # this needs to come last\n  a: 1\n}\n\n# quokka:sort\n%{\n  c: 3,\n  b: 2,\n  # this needs to come last\n  a: 1\n}\n```\n\nwould yield\n\n```elixir\n# quokka:skip-sort\n%{c: 3, b: 2, a: 1}\n\n%{a: 1, b: 2, c: 3}\n\n%{\n  c: 3,\n  b: 2,\n  # this needs to come last\n  a: 1\n}\n\n# quokka:sort\n%{\n  # this needs to come last\n  a: 1,\n  b: 2,\n  c: 3\n}\n```\n\nWhen `autosort: [:schema]` is enabled:\n\n```elixir\ndefmodule MySchema do\n  use Ecto.Schema\n\n  schema \"my_schema\" do\n    field :name, :string\n    field :age, :integer\n    field :email, :string\n    has_many :posts, Post\n    has_one :profile, Profile\n    belongs_to :user, User\n    many_to_many :tags, Tag, join_through: \"my_schema_tags\"\n  end\nend\n```\n\nwould yield:\n\n```elixir\ndefmodule MySchema do\n  use Ecto.Schema\n\n  schema \"my_schema\" do\n    belongs_to(:user, User)\n\n    has_many(:posts, Post)\n\n    has_one(:profile, Profile)\n\n    many_to_many(:tags, Tag, join_through: \"my_schema_tags\")\n\n    field(:age, :integer)\n    field(:email, :string)\n    field(:name, :string)\n  end\nend\n```","ref":"comment_directives.html#autosort"},{"type":"extras","title":"Control Flow Macros (if, case, ...)","doc":"# Control Flow Macros (`case`, `if`, `unless`, `cond`, `with`)\n\nElixir's Kernel documentation refers to these structures as \"macros for control-flow\".\nWe often refer to them as \"blocks\" in our changelog, which is a much worse name, to be sure.\n\n## `if` and `unless`\n\nQuokka removes `else: nil` clauses:\n\n```elixir\nif a, do: b, else: nil\n# styled:\nif a, do: b\n```\n\nQuokka removes `unless` since it is being deprecated in Elixir 1.18. This implicitly addresses [`Credo.Check.Refactor.NegatedConditionsInUnless`](https://hexdocs.pm/credo/Credo.Check.Refactor.NegatedConditionsInUnless.html) and [`Credo.Check.Refactor.NegatedConditionsWithElse`](https://hexdocs.pm/credo/Credo.Check.Refactor.NegatedConditionsWithElse.html).\n\n```elixir\n# Given:\nunless a, do: b\n# Styled:\nif a, do: b\n```","ref":"control_flow_macros.html"},{"type":"extras","title":"Negation Inversion - Control Flow Macros (if, case, ...)","doc":"This addresses [`Credo.Check.Refactor.NegatedConditionsWithElse`](https://hexdocs.pm/credo/Credo.Check.Refactor.NegatedConditionsWithElse.html). This is not configurable.\n\nQuokka removes negators in the head of `if` statements by \"inverting\" the statement.\nThe following operators are considered \"negators\": `!`, `not`, `!=`, `!==`\n\nExamples:\n\n```elixir\n\n\n# negated `if` statements with an `else` clause have their clauses inverted and negation removed\nif !x, do: y, else: z\n# Styled:\nif x, do: z, else: y\n\n# negated `unless` statements are rewritten to `if`\nunless x != y, do: z\n# B styled:\nif x == y, do: z\n\n# `unless` with `else` is verboten; these are always rewritten to `if` statements\nunless x, do: y, else: z\n# styled:\nif x, do: z, else: y\n```\n\nBecause elixir relies on truthy/falsey values for its `if` statements, boolean casting is unnecessary and so double negation is simply removed.\n\n```elixir\nif !!x, do: y\n# styled:\nif x, do: y\n```\n\n## `cond`\n\nThis addresses [`Credo.Check.Refactor.CondStatements`](https://hexdocs.pm/credo/Credo.Check.Refactor.CondStatements.html). This is not configurable.\n\nQuokka has only one `cond` statement rewrite: replace 2-clause statements with `if` statements.\n\n```elixir\n# Given\ncond do\n  a -> b\n  true -> c\nend\n# Styled\nif a do\n  b\nelse\n  c\nend\n```\n\n## `with`\n\nThis addresses [`Credo.Check.Readability.WithSingleClause`](https://hexdocs.pm/credo/Credo.Check.Readability.WithSingleClause.html), [`Credo.Check.Refactor.RedundantWithClauseResult`](https://hexdocs.pm/credo/Credo.Check.Refactor.RedundantWithClauseResult.html), and [`Credo.Check.Refactor.WithClauses`](https://hexdocs.pm/credo/Credo.Check.Refactor.WithClauses.html). This is not configurable.","ref":"control_flow_macros.html#negation-inversion"},{"type":"extras","title":"Remove Identity Else Clause - Control Flow Macros (if, case, ...)","doc":"Like if statements with `nil` as their else clause, the identity `else` clause is the default for `with` statements and so is removed.\n\n```elixir\n# Given\nwith :ok <- b(), :ok <- b() do\n  foo()\nelse\n  error -> error\nend\n# Styled:\nwith :ok <- b(), :ok <- b() do\n  foo()\nend\n```","ref":"control_flow_macros.html#remove-identity-else-clause"},{"type":"extras","title":"Remove The Statement Entirely - Control Flow Macros (if, case, ...)","doc":"While you might think \"surely this kind of code never appears in the wild\", it absolutely does. Typically it's the result of someone refactoring a pattern away and not looking at the larger picture and realizing that the with statement now serves no purpose.\n\nMaybe someday the compiler will warn about these use cases. Until then, Quokka to the rescue.\n\n```elixir\n# Given:\nwith a <- b(),\n     c <- d(),\n     e <- f(),\n     do: g,\n     else: (_ -> h)\n# Styled:\na = b()\nc = d()\ne = f()\ng\n\n# Given\nwith value <- arg do\n  value\nend\n# Styled:\narg\n```","ref":"control_flow_macros.html#remove-the-statement-entirely"},{"type":"extras","title":"Replace `_ <- rhs` with `rhs` - Control Flow Macros (if, case, ...)","doc":"This is another case of \"less is more\" for the reader.\n\n```elixir\n# Given\nwith :ok <- x,\n     _ <- y(),\n     {:ok, _} <- z do\n  :ok\nend\n# Styled:\nwith :ok <- x,\n     y(),\n     {:ok, _} <- z do\n  :ok\nend\n```","ref":"control_flow_macros.html#replace-_-rhs-with-rhs"},{"type":"extras","title":"Replace non-branching `bar <-` with `bar =` - Control Flow Macros (if, case, ...)","doc":"`<-` is for branching. If the lefthand side is the trivial match (a bare variable), Quokka rewrites it to use the `=` operator instead.\n\n```elixir\n# Given\nwith :ok <- foo(),\n     bar <- baz(),\n     :ok <- woo(),\n     do: {:ok, bar}\n# Styled\n with :ok <- foo(),\n      bar = baz(),\n      :ok <- woo(),\n      do: {:ok, bar}\n```","ref":"control_flow_macros.html#replace-non-branching-bar-with-bar"},{"type":"extras","title":"Move assignments from `with` statement head - Control Flow Macros (if, case, ...)","doc":"Just because any program _could_ be written entirely within the head of a `with` statement doesn't mean it should be!\n\nQuokka moves assignments that aren't trapped between `<-` outside of the head. Combined with the non-pattern-matching replacement above, we get the following:\n\n```elixir\n# Given\nwith foo <- bar,\n     x = y,\n     :ok <- baz,\n     bop <- boop,\n     :ok <- blop,\n     foo <- bar,\n     :success = hope_this_works! do\n  :ok\nend\n# Styled:\nfoo = bar\nx = y\n\nwith :ok <- baz,\n     bop = boop,\n     :ok <- blop do\n  foo = bar\n  :success = hope_this_works!\n  :ok\nend\n```","ref":"control_flow_macros.html#move-assignments-from-with-statement-head"},{"type":"extras","title":"Remove redundant final clause - Control Flow Macros (if, case, ...)","doc":"If the pattern of the final clause of the head is also the `with` statements `do` body, quokka nixes the final match and makes the right hand side of the clause into the do body.\n\n```elixir\n# Given\nwith {:ok, a} <- foo(),\n     {:ok, b} <- bar(a) do\n  {:ok, b}\nend\n# Styled:\nwith {:ok, a} <- foo() do\n  bar(a)\nend\n```","ref":"control_flow_macros.html#remove-redundant-final-clause"},{"type":"extras","title":"Replace with `case` - Control Flow Macros (if, case, ...)","doc":"A `with` statement with a single clause in the head and an `else` body is really just a `case` statement putting on airs.\n\n```elixir\n# Given:\nwith :ok <- foo do\n  :success\nelse\n  :fail -> :failure\n  error -> error\nend\n# Styled:\ncase foo do\n  :ok -> :success\n  :fail -> :failure\n  error -> error\nend\n```","ref":"control_flow_macros.html#replace-with-case"},{"type":"extras","title":"Replace with `if` - Control Flow Macros (if, case, ...)","doc":"Given Quokka rewrites trivial `case` to `if`, it shouldn't be a surprise that that same rule means that `with` can be rewritten to `if` in some cases.\n\n```elixir\n# Given:\nwith true <- foo(), bar <- baz() do\n  {:ok, bar}\nelse\n  _ -> :error\nend\n# Styled:\nif foo() do\n  bar = baz()\n  {:ok, bar}\nelse\n  :error\nend\n```","ref":"control_flow_macros.html#replace-with-if"},{"type":"extras","title":"Mix Configs (config/config.exs, ...)","doc":"# Mix Configs\n\n> #### THIS CAN BREAK YOUR PROGRAM {: .warning}\n>\n> It's important to double check your configuration after running Quokka on it for the first time.\n\nThis can be enabled or disabled by setting the `exclude: :configs` option in your `.formatter.exs` file. See the [README](../README.md#configuration) for more information.\n\nMix Config files have their config stanzas sorted. Similar to the sorting of aliases, this delivers consistency to an otherwise arbitrary world, and can even help catch bugs like configuring the same key multiple times.\n\nA file is considered a config file if\n\n1. its path matches `~r|config/.*\\.exs|` `~r|rel/overlays/.*\\.exs|`\n2. the file has `import Config`\n\nOnce a file is detected as a mix config, its `config/2,3` stanzas are grouped and ordered like so:\n\n- group config stanzas separated by assignments (`x = y`) together\n- sort each group according to erlang term sorting\n- move all existing assignments between the config stanzas to above the stanzas (without changing their ordering)\n\nImagine your application configures the same value twice, once with an invalid or application breaking value, and then again with a correct value, like so:\n\n```elixir\nstring = \"i am a string\"\natom = :i_am_an_atom\n\nconfig :my_app, value_must_be_an_atom: string\n...\n...\nconfig :my_app, value_must_be_an_atom: atom\n```\n\nWhen quokka sorts the configuration file, this dormant mistake can become a bug if the sorting changes the order such that the invalid value takes precedence (aka comes last)\n\n```elixir\nstring = \"i am a string\"\natom = :i_am_an_atom\n\n# The value that must be an atom is now a string!\nconfig :my_app, value_must_be_an_atom: atom\nconfig :my_app, value_must_be_an_atom: string\n```","ref":"mix_configs.html"},{"type":"extras","title":"Examples - Mix Configs (config/config.exs, ...)","doc":"Sorts configs by erlang term ordering:\n\n```elixir\n# Given\nimport Config\n\nconfig :z, :x, :c\nconfig :a, :b, :c\nconfig :y, :x, :z\nconfig :a, :c, :d\n\n# Styled:\nimport Config\n\nconfig :a, :b, :c\nconfig :a, :c, :d\n\nconfig :y, :x, :z\n\nconfig :z, :x, :c\n```\n\nNon-config statements break the file up into chunks, where each chunk is sorted separately relative to itself.\n\n```elixir\n# Given\nimport Config\n\nconfig :z, :x, :c\nconfig :a, :b, :c\nvar = \"value\"\nconfig :y, :x, var\nconfig :a, :c, var\n\n# Styled:\nimport Config\n\nconfig :a, :b, :c\nconfig :z, :x, :c\n\nvar = \"value\"\n\nconfig :a, :c, var\nconfig :y, :x, var\n```","ref":"mix_configs.html#examples"},{"type":"extras","title":"Module Directives (use, alias, ...)","doc":"","ref":"module_directives.html"},{"type":"extras","title":"Skipping Module Reordering - Module Directives (use, alias, ...)","doc":"If you want to skip module reordering, you can add the following comment to the top of the file:\n\n```elixir\n# quokka:skip-module-reordering\n```\n\nThis will prevent Quokka from doing any of the below transformations.","ref":"module_directives.html#skipping-module-reordering"},{"type":"extras","title":"Directive Expansion - Module Directives (use, alias, ...)","doc":"This addresses:\n\n- [`Credo.Check.Consistency.MultiAliasImportRequireUse`](https://hexdocs.pm/credo/Credo.Check.Consistency.MultiAliasImportRequireUse.html). Note that while Credo will pass as long as multi alias usage is consistent, Quokka will only expand multi-alias statements. It will not compress multiple aliases into a single statement.\n- [`Credo.Check.Readability.MultiAlias`](https://hexdocs.pm/credo/Credo.Check.Readability.MultiAlias.html). Note that this is configurable and Quokka will check the Credo config to determine if aliases should be expanded.\n- [`Credo.Check.Readability.UnnecessaryAliasExpansion`](https://hexdocs.pm/credo/Credo.Check.Readability.UnnecessaryAliasExpansion.html). This is not configurable.\n\nExpands `Module.{SubmoduleA, SubmoduleB}` to their explicit forms for ease of searching.\n\n```elixir\n# Before\nimport Foo.{Bar, Baz, Bop}\nalias Foo.{Bar, Baz.A, Bop}\n\n# After\nimport Foo.Bar\nimport Foo.Baz\nimport Foo.Bop\n\nalias Foo.Bar\nalias Foo.Baz.A\nalias Foo.Bop\n```","ref":"module_directives.html#directive-expansion"},{"type":"extras","title":"Directive Organization - Module Directives (use, alias, ...)","doc":"This addresses:\n- [`Credo.Check.Readability.AliasOrder`](https://hexdocs.pm/credo/Credo.Check.Readability.AliasOrder.html). While it is not possible to disable this rewrite, Quokka will respect the `:sort_method` Credo config.\n- [`Credo.Check.Readability.StrictModuleLayout`](https://hexdocs.pm/credo/Credo.Check.Readability.StrictModuleLayout.html). While it is not possible to disable this rewrite, Quokka will respect the `:order` Credo config.\n\nModules directives are sorted into the following order by default:\n\n* `@shortdoc`\n* `@moduledoc`\n* `@behaviour`\n* `use`\n* `import` (sorted alphabetically)\n* `alias` (sorted alphabetically)\n* `require` (sorted alphabetically)\n* everything else (order unchanged)","ref":"module_directives.html#directive-organization"},{"type":"extras","title":"Before - Module Directives (use, alias, ...)","doc":"```elixir\ndefmodule Foo do\n  @behaviour Lawful\n  alias A.A\n  require A\n\n  use B\n\n  def c(x), do: y\n\n  import C\n  @behaviour Chaotic\n  @doc \"d doc\"\n  def d do\n    alias X.X\n    alias H.H\n\n    alias Z.Z\n    import Ecto.Query\n    X.foo()\n  end\n  @shortdoc \"it's pretty short\"\n  import A\n  alias C.C\n  alias D.D\n\n  require C\n  require B\n\n  use A\n\n  alias C.C\n  alias A.A\n\n  @moduledoc \"README.md\"\n             |> File.read!()\n             |> String.split(\"<!-- MDOC !-->\")\n             |> Enum.fetch!(1)\nend\n```","ref":"module_directives.html#before"},{"type":"extras","title":"After - Module Directives (use, alias, ...)","doc":"```elixir\ndefmodule Foo do\n  @shortdoc \"it's pretty short\"\n  @moduledoc \"README.md\"\n             |> File.read!()\n             |> String.split(\"<!-- MDOC !-->\")\n             |> Enum.fetch!(1)\n  @behaviour Chaotic\n  @behaviour Lawful\n\n  use B\n  use A.A\n\n  import A.A\n  import C\n\n  alias A.A\n  alias C.C\n  alias D.D\n\n  require A\n  require B\n  require C\n\n  def c(x), do: y\n\n  @doc \"d doc\"\n  def d do\n    import Ecto.Query\n\n    alias H.H\n    alias X.X\n    alias Z.Z\n\n    X.foo()\n  end\nend\n```\n\nIf any line previously relied on an alias, the alias is fully expanded when it is moved above the alias:\n\n```elixir\n# Given\nalias Foo.Bar\nimport Bar\n# Styled\nimport Foo.Bar\n\nalias Foo.Bar\n```","ref":"module_directives.html#after"},{"type":"extras","title":"Alias Lifting - Module Directives (use, alias, ...)","doc":"This addresses [`Credo.Check.Design.AliasUsage`](https://hexdocs.pm/credo/Credo.Check.Design.AliasUsage.html). The Credo configs supported by Quokka include:\n\n- `:lift_alias_excluded_namespaces`\n- `:lift_alias_excluded_lastnames`\n- `:if_nested_deeper_than`\n- `:if_called_more_often_than`\n\nWhen a module with greater than `:if_nested_deeper_than` nested parts is referenced more than `:if_called_more_often_than` times, Quokka creates a new alias for that module and uses it.\n\n```elixir\n# Given\nrequire A.B.C\n\nA.B.C.foo()\nA.B.C.bar()\n\n# Styled\nalias A.B.C\n\nrequire C\n\nC.foo()\nC.bar()\n```","ref":"module_directives.html#alias-lifting"},{"type":"extras","title":"Collisions - Module Directives (use, alias, ...)","doc":"Quokka won't lift aliases that will collide with existing aliases, and likewise won't lift any module whose name would collide with a standard library name.","ref":"module_directives.html#collisions"},{"type":"extras","title":"Pipe Chains","doc":"# Pipe Chains","ref":"pipes.html"},{"type":"extras","title":"Pipe Start - Pipe Chains","doc":"- If [`Credo.Check.Readability.BlockPipe`](https://hexdocs.pm/credo/Credo.Check.Readability.BlockPipe.html) is enabled, Quokka will prevent using blocks with pipes. Quokka respects the `:exclude` Credo opt.\n- If [`Credo.Check.Refactor.PipeChainStart`](https://hexdocs.pm/credo/Credo.Check.Refactor.PipeChainStart.html) is enabled, Quokka will rewrite the start of a pipechain to be a 0-arity function, a raw value, or a variable. Quokka respects the `:excluded_functions` and `excluded_argument_types` Credo opts.\n\nBased on the Credo config, Quokka will rewrite the start of a pipechain to be a 0-arity function, a raw value, or a variable.\n\n```elixir\nEnum.at(enum, 5)\n|> IO.inspect()\n\n# Styled:\nenum\n|> Enum.at(5)\n|> IO.inspect()\n```\n\nIf the start of a pipe is a block expression, Quokka will create a new variable to store the result of that expression and make that variable the start of the pipe.\n\n```elixir\nif a do\n  b\nelse\n  c\nend\n|> Enum.at(4)\n|> IO.inspect()\n\n# Styled:\nif_result =\n  if a do\n    b\n  else\n    c\n  end\n\nif_result\n|> Enum.at(4)\n|> IO.inspect()\n```","ref":"pipes.html#pipe-start"},{"type":"extras","title":"Add parenthesis to function calls in pipes - Pipe Chains","doc":"This addresses [`Credo.Check.Readability.OneArityFunctionInPipe`](https://hexdocs.pm/credo/Credo.Check.Readability.OneArityFunctionInPipe.html). This is not configurable.\n\n```elixir\na |> b |> c |> d\n# Styled:\na |> b() |> c() |> d()\n```","ref":"pipes.html#add-parenthesis-to-function-calls-in-pipes"},{"type":"extras","title":"Remove Unnecessary `then/2` - Pipe Chains","doc":"When the piped argument is being passed as the first argument to the inner function, there's no need for `then/2`.\n\n```elixir\na |> then(&f(&1, ...)) |> b()\n# Styled:\na |> f(...) |> b()\n```\n\n- add parens to function calls `|> fun |>` => `|> fun() |>`","ref":"pipes.html#remove-unnecessary-then-2"},{"type":"extras","title":"Add `then/2` when defining and calling anonymous functions in pipes - Pipe Chains","doc":"- Addresses [`Credo.Check.Readability.PipeIntoAnonymousFunctions`](https://hexdocs.pm/credo/Credo.Check.Readability.PipeIntoAnonymousFunctions.html) by rewriting anonymous function invocations to use `then/2`. This is not configurable.\n\n```elixir\na |> (fn x -> x end).() |> c()\n# Styled:\na |> then(fn x -> x end) |> c()\n```","ref":"pipes.html#add-then-2-when-defining-and-calling-anonymous-functions-in-pipes"},{"type":"extras","title":"Piped function optimizations - Pipe Chains","doc":"Two function calls into one! Fewer steps is always nice.\n\n```elixir\n# reverse |> concat => reverse/2\na |> Enum.reverse() |> Enum.concat(enum) |> ...\n# Styled:\na |> Enum.reverse(enum) |> ...\n\n# filter |> count => count(filter)\na |> Enum.filter(filterer) |> Enum.count() |> ...\n# Styled:\na |> Enum.count(filterer) |> ...\n\n# map |> join => map_join\na |> Enum.map(mapper) |> Enum.join(joiner) |> ...\n# Styled:\na |> Enum.map_join(joiner, mapper) |> ...\n\n# Enum.map |> X.new() => X.new(mapper)\n# where X is one of: Map, MapSet, Keyword\na |> Enum.map(mapper) |> Map.new() |> ...\n# Styled:\na |> Map.new(mapper) |> ...\n\n# Enum.map |> Enum.into(empty_collectable) => X.new(mapper)\n# Where empty_collectable is one of `%{}`, `Map.new()`, `Keyword.new()`, `MapSet.new()`\n# Given:\na |> Enum.map(mapper) |> Enum.into(%{}) |> ...\n# Styled:\na |> Map.new(mapper) |> ...\n\n# Given:\na |> b() |> Stream.each(fun) |> Stream.run()\na |> b() |> Stream.map(fun) |> Stream.run()\n# Styled:\na |> b() |> Enum.each(fun)\na |> b() |> Enum.each(fun)\n```","ref":"pipes.html#piped-function-optimizations"},{"type":"extras","title":"Unpiping Single Pipes - Pipe Chains","doc":"This addresses [`Credo.Check.Readability.SinglePipe`](https://hexdocs.pm/credo/Credo.Check.Readability.SinglePipe.html). If the Credo check is enabled, Quokka will rewrite pipechains with a single pipe to be function calls. Notably, this rule combined with the optimizations rewrites above means some chains with more than one pipe will also become function calls.\n\n```elixir\nfoo = bar |> baz()\n# Styled:\nfoo = baz(bar)\n\nmap = a |> Enum.map(mapper) |> Map.new()\n# Styled:\nmap = Map.new(a, mapper)\n```","ref":"pipes.html#unpiping-single-pipes"},{"type":"extras","title":"Basic Styles","doc":"# Simple (Single Node) Styles\n\nFunction Performance & Readability Optimizations\n\nOptimizing for either performance or readability, probably both!\nThese apply to the piped versions as well","ref":"styles.html"},{"type":"extras","title":"Strings to Sigils - Basic Styles","doc":"This addresses [`Credo.Check.Readability.StringSigils`](https://hexdocs.pm/credo/Credo.Check.Readability.StringSigils.html). This is not configurable.\n\nRewrites strings with 4 or more escaped quotes to string sigils with an alternative delimiter.\nThe delimiter will be one of `\" ( { | [ ' < /`, chosen by which would require the fewest escapes, and otherwise preferred in the order listed.\n\n```elixir\n# Before\n\"{\\\"errors\\\":[\\\"Not Authorized\\\"]}\"\n# Styled\n~s({\"errors\":[\"Not Authorized\"]})\n```","ref":"styles.html#strings-to-sigils"},{"type":"extras","title":"Large Base 10 Numbers - Basic Styles","doc":"This addresses [`Credo.Check.Readability.LargeNumbers`](https://hexdocs.pm/credo/Credo.Check.Readability.LargeNumbers.html). Quokka will respect the `:only_greater_than` Credo opt.\n\nStyle base 10 numbers with 5 or more digits to have a `_` every three digits.\nFormatter already does this except it doesn't rewrite \"typos\" like `100_000_0`.\n\nIf you're concerned that this breaks your team's formatting for things like \"cents\" (like \"$100\" being written as `100_00`),\nconsider using a library made for denoting currencies rather than raw elixir integers.\n\n| Before             | After                                                 |\n| ------------------ | ----------------------------------------------------- |\n| `10000 `           | `10_000`                                              |\n| `1_0_0_0_0`        | `10_000` (elixir's formatter leaves the former as-is) |\n| `-543213 `         | `-543_213`                                            |\n| `123456789 `       | `123_456_789`                                         |\n| `55333.22 `        | `55_333.22`                                           |\n| `-123456728.0001 ` | `-123_456_728.0001`                                   |","ref":"styles.html#large-base-10-numbers"},{"type":"extras","title":"Efficient Function Rewrites - Basic Styles","doc":"All these rewrites are configurable by setting the `:inefficient_function_rewrites` option in your `.formatter.exs` file. See the [README](../README.md#configuration) for more information.\n\n### `Enum.into` -> `X.new`\n\nThis rewrite is applied when the collectable is a new map, keyword list, or mapset via `Enum.into/2,3`.\n\nThis is an improvement for the reader, who gets a more natural language expression: \"make a new map from enum\" vs \"enumerate enum and collect its elements into a new map\"\n\nNote that all of the examples below also apply to pipes (`enum |> Enum.into(...)`)\n\n| Before                                     | After                               |\n| ------------------------------------------ | ----------------------------------- |\n| `Enum.into(enum, %{})`                     | `Map.new(enum)`                     |\n| `Enum.into(enum, Map.new())`               | `Map.new(enum)`                     |\n| `Enum.into(enum, Keyword.new())`           | `Keyword.new(enum)`                 |\n| `Enum.into(enum, MapSet.new())`            | `Keyword.new(enum)`                 |\n| `Enum.into(enum, %{}, fn x -> {x, x} end)` | `Map.new(enum, fn x -> {x, x} end)` |\n| `Enum.into(enum, [])`                      | `Enum.to_list(enum)`                |\n| `Enum.into(enum, [], mapper)`              | `Enum.map(enum, mapper)`            |","ref":"styles.html#efficient-function-rewrites"},{"type":"extras","title":"Map/Keyword.merge w/ single key literal -> X.put - Basic Styles","doc":"`Keyword.merge` and `Map.merge` called with a literal map or keyword argument with a single key are rewritten to the equivalent `put`, a cognitively simpler function.\n\n```elixir\n# Before\nKeyword.merge(kw, [key: :value])\n# Styled\nKeyword.put(kw, :key, :value)\n\n# Before\nMap.merge(map, %{key: :value})\n# Styled\nMap.put(map, :key, :value)\n\n# Before\nMap.merge(map, %{key => value})\n# Styled\nMap.put(map, key, value)\n\n# Before\nmap |> Map.merge(%{key: value}) |> foo()\n# Styled\nmap |> Map.put(:key, value) |> foo()\n```","ref":"styles.html#map-keyword-merge-w-single-key-literal-x-put"},{"type":"extras","title":"Map/Keyword.drop w/ single key -> X.delete - Basic Styles","doc":"In the same vein as the `merge` style above, `[Map|Keyword].drop/2` with a single key to drop are rewritten to use `delete/2`\n\n```elixir\n# Before\nMap.drop(map, [key])\n# Styled\nMap.delete(map, key)\n\n# Before\nKeyword.drop(kw, [key])\n# Styled\nKeyword.delete(kw, key)\n```\n\n### `Enum.reverse/1` and concatenation -> `Enum.reverse/2`\n\n`Enum.reverse/2` optimizes a two-step reverse and concatenation into a single step.\n\n```elixir\n# Before\nEnum.reverse(foo) ++ bar\n# Styled\nEnum.reverse(foo, bar)\n\n# Before\nbaz |> Enum.reverse() |> Enum.concat(bop)\n# Styled\nEnum.reverse(baz, bop)\n```\n\n### `Timex.now/0` ->` DateTime.utc_now/0`\n\nTimex certainly has its uses, but knowing what stdlib date/time struct is returned by `now/0` is a bit difficult!\n\nWe prefer calling the actual function rather than its rename in Timex, helping the reader by being more explicit.\n\nThis also hews to our internal styleguide's \"Don't make one-line helper functions\" guidance.\n\n### `DateModule.compare/2` -> `DateModule.[before?|after?]`\n\nAgain, the goal is readability and maintainability. `before?/2` and `after?/2` were implemented long after `compare/2`,\nso it's not unusual that a codebase needs a lot of refactoring to be brought up to date with these new functions.\nThat's where Quokka comes in!\n\nThe examples below use `DateTime.compare/2`, but the same is also done for `NaiveDateTime|Time|Date.compare/2`\n\n```elixir\n# Before\nDateTime.compare(start, end_date) == :gt\n# Styled\nDateTime.after?(start, end_date)\n\n# Before\nDateTime.compare(start, end_date) == :lt\n# Styled\nDateTime.before?(start, end_date)\n```","ref":"styles.html#map-keyword-drop-w-single-key-x-delete"},{"type":"extras","title":"Filter count - Basic Styles","doc":"This addresses [`Credo.Check.Refactor.FilterCount`](https://hexdocs.pm/credo/Credo.Check.Refactor.FilterCount.html). This is not configurable.\n\n```elixir\n[1, 2, 3, 4, 5]\n|> Enum.filter(fn x -> rem(x, 3) == 0 end)\n|> Enum.count()\n\n# Styled:\nEnum.count([1, 2, 3, 4, 5], fn x -> rem(x, 3) == 0 end)\n```","ref":"styles.html#filter-count"},{"type":"extras","title":"Map into - Basic Styles","doc":"This addresses [`Credo.Check.Refactor.MapInto`](https://hexdocs.pm/credo/Credo.Check.Refactor.MapInto.html). This is not configurable.\n\n```elixir\n[:apple, :banana, :carrot]\n|> Enum.map(&({&1, to_string(&1)}))\n|> Enum.into(%{})\n\n# Styled:\nMap.new([:apple, :banana, :carrot], &{&1, to_string(&1)})\n```","ref":"styles.html#map-into"},{"type":"extras","title":"Map join - Basic Styles","doc":"This addresses [`Credo.Check.Refactor.MapJoin`](https://hexdocs.pm/credo/Credo.Check.Refactor.MapJoin.html). This is not configurable.\n\n```elixir\n[\"a\", \"b\", \"c\"]\n|> Enum.map(&String.upcase/1)\n|> Enum.join(\", \")\n\n# Styled:\nEnum.join([\"a\", \"b\", \"c\"], \", \", &String.upcase/1)\n```","ref":"styles.html#map-join"},{"type":"extras","title":"Implicit Try - Basic Styles","doc":"Quokka will rewrite functions whose entire body is a try/do to instead use the implicit try syntax. Addresses [`Credo.Check.Readability.PreferImplicitTry`](https://hexdocs.pm/credo/Credo.Check.Readability.PreferImplicitTry.html). This is not configurable.\n\n\nThe following example illustrates the most complex case, but Quokka happily handles just basic try do/rescue bodies just as easily.","ref":"styles.html#implicit-try"},{"type":"extras","title":"Before - Basic Styles","doc":"```elixir\ndef foo() do\n  try do\n    uh_oh()\n  rescue\n    exception -> {:error, exception}\n  catch\n    :a_throw -> {:error, :threw!}\n  else\n    try_has_an_else_clause? -> {:did_you_know, try_has_an_else_clause?}\n  after\n    :done\n  end\nend\n```","ref":"styles.html#before"},{"type":"extras","title":"After - Basic Styles","doc":"```elixir\ndef foo() do\n  uh_oh()\nrescue\n  exception -> {:error, exception}\ncatch\n  :a_throw -> {:error, :threw!}\nelse\n  try_has_an_else_clause? -> {:did_you_know, try_has_an_else_clause?}\nafter\n  :done\nend\n```","ref":"styles.html#after"},{"type":"extras","title":"Add parenthesis to 0-arity functions and macro definitions - Basic Styles","doc":"This addresses [`Credo.Check.Readability.ParenthesesOnZeroArityDefs`](https://hexdocs.pm/credo/Credo.Check.Readability.ParenthesesOnZeroArityDefs.html). Quokka will add or remove parens from function calls in pipes when the function has no arguments based on the Credo config. If the Credo check is disabled, Quokka will not add or remove parens.\n\n```elixir\n# Behavior if .credo.exs has `Credo.Check.Readability.ParenthesesOnZeroArityDefs, parens: true`\n# Before\ndef foo\ndefp foo\ndefmacro foo\ndefmacrop foo\n\n# Styled\ndef foo()\ndefp foo()\ndefmacro foo()\ndefmacrop foo()\n```\n\n```elixir\n# Behavior if .credo.exs has `Credo.Check.Readability.ParenthesesOnZeroArityDefs, parens: false`\n# Before\ndef foo()\ndefp foo()\ndefmacro foo()\ndefmacrop foo()\n\n# Styled\ndef foo\ndefp foo\ndefmacro foo\ndefmacrop foo\n```","ref":"styles.html#add-parenthesis-to-0-arity-functions-and-macro-definitions"},{"type":"extras","title":"Elixir Deprecation Rewrites - Basic Styles","doc":"| Before                                       | After                              | Elixir Version |\n| -------------------------------------------- | ---------------------------------- | ------------- |\n| `Logger.warn`                                | `Logger.warning`                   | 1.15+         |\n| `Path.safe_relative_to/2`                    | `Path.safe_relative/2`             | 1.15+         |\n| `~R/my_regex/`                               | `~r/my_regex/`                     | 1.15+         |\n| `Enum/String.slice/2` with decreasing ranges | add explicit steps to the range \\* | 1.15+         |\n| `Date.range/2` with decreasing range         | `Date.range/3` \\*                  | 1.15+         |\n| `IO.read/bin_read` with `:all` option        | replace `:all` with `:eof`         | 1.15+         |\n| `File.stream!(path, [encoding: :utf8, trim_bom: true], :line)` (`:line` `:bytes` deprecated) | `File.stream!(path, :line, encoding: :utf8, trim_bom: true)` | 1.16+         |\n| `:timer.units(x)`                            | `to_time(unit: x)`                 | 1.17+         |\n| `first..last = ...`                         | `first..last//_ = ...`             | 1.18+         |\n| `List.zip(list1, list2)`                    | `Enum.zip(list1, list2)`           | 1.18+         |\n| `%Foo{x \\| y} => %{x \\| y}`                 | `%{x \\| y}`                        | 1.19+         |\n\\* For both of the \"decreasing range\" changes, the rewrite can only be applied if the range is being passed as an argument to the function.","ref":"styles.html#elixir-deprecation-rewrites"},{"type":"extras","title":"Putting variable matching on the right - Basic Styles","doc":"```elixir\n# Before\ncase foo do\n  bar = %{baz: baz? = true} -> :baz?\n  opts = [[a = %{}] | _] -> a\nend\n# Styled:\ncase foo do\n  %{baz: true = baz?} = bar -> :baz?\n  [[%{} = a] | _] = opts -> a\nend\n\n# Before\nwith {:ok, result = %{}} <- foo, do: result\n# Styled\nwith {:ok, %{} = result} <- foo, do: result\n\n# Before\ndef foo(bar = %{baz: baz? = true}, opts = [[a = %{}] | _]), do: :ok\n# Styled\ndef foo(%{baz: true = baz?} = bar, [[%{} = a] | _] = opts), do: :ok\n```","ref":"styles.html#putting-variable-matching-on-the-right"},{"type":"extras","title":"Drops superfluous `= _` in pattern matching - Basic Styles","doc":"```elixir\n# Before\ndef foo(_ = bar), do: bar\n# Styled\ndef foo(bar), do: bar\n\n# Before\ncase foo do\n  _ = bar -> :ok\nend\n# Styled\ncase foo do\n  bar -> :ok\nend\n```","ref":"styles.html#drops-superfluous-_-in-pattern-matching"},{"type":"extras","title":"Use Implicit Try - Basic Styles","doc":"```elixir\n# before\ndef foo d\n  try do\n    throw_ball()\n  catch\n    :ball -> :caught\n  end\nend\n\n# Styled:\ndef foo d\n  throw_ball()\ncatch\n  :ball -> :caught\nend\n```","ref":"styles.html#use-implicit-try"},{"type":"extras","title":"Shrink Function Definitions to One Line When Possible - Basic Styles","doc":"```elixir\n# Before\n\ndef save(\n       # Socket comment\n       %Socket{assigns: %{user: user, live_action: :new}} = initial_socket,\n       # Params comment\n       params\n     ),\n     do: :ok\n\n# Styled\n\n# Socket comment\n# Params comment\ndef save(%Socket{assigns: %{user: user, live_action: :new}} = initial_socket, params), do: :ok\n```","ref":"styles.html#shrink-function-definitions-to-one-line-when-possible"},{"type":"extras","title":"Parameter Pattern Matching Consistency - Basic Styles","doc":"This addresses [`Credo.Check.Consistency.ParameterPatternMatching`](https://hexdocs.pm/credo/Credo.Check.Consistency.ParameterPatternMatching.html). Note that while this is configurable in credo, Quokka will rewrite all matches to be on the right hand side of the `=` sign.\n\n```elixir\n# Before\ndef process(user = %User{age: age}) when age >= 18 do\n  # ...\nend\n\n# Styled\ndef process(%User{age: age} = user) when age >= 18 do\n  # ...\nend\n\n# Before - match on left\ndef process(opts = [foo: foo]) do\n  # ...\nend\n\n# Styled - match on right\ndef process([foo: foo] = opts) do\n  # ...\nend\n```","ref":"styles.html#parameter-pattern-matching-consistency"},{"type":"extras","title":"Line Length - Basic Styles","doc":"This addresses [`Credo.Check.Readability.MaxLineLength`](https://hexdocs.pm/credo/Credo.Check.Readability.MaxLineLength.html). Quokka will respect the minimum of the `:line_length` configuration between `.credo.exs` and `.formatter.exs` when determining whether to split lines. When possible, will compress code onto a single line if it fits within the configured length.\n\n```elixir\n# Before - Multiple lines when it could fit on one\ndef process_user(\n  name,\n  email\n) do\n  UserProcessor.handle(name, email)\nend\n\n# Styled - Compressed to one line since it fits\ndef process_user(name, email) do\n  UserProcessor.handle(name, email)\nend\n\n# Before - Long line exceeding configured length\ndef process_user_data(user_name, email, age, occupation, address, phone_number, preferences), do: UserProcessor.handle_data(user_name, email, age, occupation, address, phone_number, preferences)\n\n# Styled - Split across multiple lines to respect length limit\ndef process_user_data(\n  user_name,\n  email,\n  age,\n  occupation,\n  address,\n  phone_number,\n  preferences\n), do: UserProcessor.handle_data(\n  user_name,\n  email,\n  age,\n  occupation,\n  address,\n  phone_number,\n  preferences\n)\n```","ref":"styles.html#line-length"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}